<script setup lang="ts">
import PanelViewContents from '@/components/Panels/PanelViewContents.vue';
import SdgUserImage from '../SdgUserImage.vue';
import { computed, ref } from 'vue';
import type { Person } from '@/types/Person';
import type { Answers } from '@/types/Answers';
import AnswerSlotContentMultipleChoice from '../AnswerSlotContentMultipleChoice.vue';
import type { Answer } from '@/types/Answer';
import CorrectAnswerEffect from '../effects/CorrectAnswerEffect.vue';

const props = defineProps<{
  person: Person;
  answers: Answers;
  showPlusOne: boolean;
  completed: boolean;
  effect?: number;
}>();

const emit = defineEmits(['onAnswerClick', 'onCorrectAnswerClick', 'onNextClick']);

let answeredCorrectly = ref(false);
let nameValue = computed(() => (answeredCorrectly.value ? props.person.displayName : 'Who am I?'));
let jobTitle = computed(() => (answeredCorrectly.value ? props.person.jobTitle : ''));
let department = computed(() => (answeredCorrectly.value ? props.person.department : ''));

const onAnswerClick = (answer: Answer) => {
  emit('onAnswerClick', answer);
  if (answer.isCorrectAnswer) {
    answeredCorrectly.value = true;
    emit('onCorrectAnswerClick');
  }
};
const onNext = () => {
  emit('onNextClick');
};
</script>

<template>
  <PanelViewContents>
    <template #title> Next question...</template>

    <template #data>
      <div class="flex flex-col items-center">
        <SdgUserImage :person="person" :width="300" :has-checkmark="answeredCorrectly" />
        <div class="text-3xl text-sdg-blue bg-white text-center">{{ nameValue }}</div>
        <div class="text-xl text-center bg-white"><span v-if="!jobTitle">&nbsp;</span>{{ jobTitle }}</div>
        <div class="text-xl text-center bg-white"><span v-if="!department">&nbsp;</span>{{ department }}</div>
      </div>
    </template>

    <template #answer>
      <AnswerSlotContentMultipleChoice :answers="answers" :completed="completed" @onAnswerClick="onAnswerClick" @onNext="onNext">
        <template #plusOne>
          <span v-if="showPlusOne" class="text-3xl text-green-600 text-center">+1</span>
        </template>
      </AnswerSlotContentMultipleChoice>
    </template>

    <template #effect>
      <CorrectAnswerEffect v-if="showPlusOne" :effect="props.effect">
        <div class="text-white text-center">+1</div>
      </CorrectAnswerEffect>
    </template>
  </PanelViewContents>
</template>
